<template>
  <p><em>This example validates that click event on disabled RuiButton don't bubble up</em></p>

  <div class="-mtd">
    <p>Button:</p>
    <rui-button :caption="caption('Increment counter')"
                :disabled="disabled"
                :waiting="waiting"
                @click="counter ++" />
  </div>

  <div class="-mtd">
    <div>Link with a click event (<em>using fake links is evil, it's only for this test</em>):</div>
    <rui-button href="#"
                :caption="caption('Increment counter')"
                :disabled="disabled"
                :waiting="waiting"
                @click.prevent="counter ++" />
  </div>

  <div class="-mtd">
    <p>"Real" link that <em>looks like</em> a button:</p>
    <rui-button href="/"
                :caption="caption('Go home')"
                :disabled="disabled"
                :waiting="waiting" />
  </div>

  <div class="-mtl">
    <p><strong>Counter: {{ counter }}</strong></p>
    <label class="-mtd"><input v-model="disabled" type="checkbox"> Disable buttons</label>
    <label class="-mtd"><input v-model="waiting" type="checkbox"> Waiting state</label>
  </div>
</template>

<script>
export default {
  data () {
    return {
      counter: 0,
      disabled: false,
      waiting: false,
    }
  },
  methods: {
    // Simple method to determine button caption based on the state
    caption (string) {
      if (this.waiting) return 'Waiting for something'
      if (this.disabled) return 'Nope'

      return string
    },
  },
}
</script>
